
from piscript.PiModule import *
import math
from piscript.Bezier import *

y = [ 0,0,1,1 ]

ps = init("bernstein0", 120,120)
beginpage()

gsave()
translate(0,5)
center()
scale(100)
translate(-0.5,-0.5)

n = len(y)-1
newpath()
moveto(0,y[0])
lineto(1.0/n, y[1])
lineto(1, y[3])
lineto(2.0/n, y[2])
fill(0.9)

newpath()
box(1,1)
stroke(0.7)

N = 64
dx = 1.0/N
x = 0
newpath()
moveto(x, bernstein(y,x))
for i in range(N):
	x += dx
	lineto(x, bernstein(y, x))
stroke()

rad = 0.016
n = len(y)-1
for i in range(n+1):
	newpath()
	circle(1.0*i/n, y[i], rad)
	fill(0.8,0,0)
	stroke(0)

grestore() 

s = "$y = [ " + str(y[0])
for i in range(1,len(y)):
	s += " , " + str(y[i])
s += " ]$"
t = texinsert(s)
x = t.width
translate(0.5*(width()-x),3)
gsave()

"""
scale(1.5)
setcolor(1,0,1)
embed(t)
"""

place(t)
grestore()

print ps

endpage()
flush()

