import re

class EncodingVector:
	
	def __init__( self ):
		self.ev = StandardEncodingVector;
		self.isStandard = True

	def setFromList( self, list ):
		self.ev = [ s for s in list ]
		self.isStandard = False

	def __str__( self ):
		if self.isStandard:
			return "Encoding Vector: StandardEncoding"
		return "Encoding Vector: %s" % str( self.ev )

	def __getitem__( self, index):
		return self.ev[index]

	def glyphListForChars( self, indices ):
		""" Returns a list of glyph names corresponding to the list of character indices"""
		return [ self.ev[c] for c in indices ]

	def glyphSetForChars( self, chars ):
		""" Returns a dictionary of glyph names corresponding to the list of character indices"""
		d = set()
		for c in chars:
			d.add( self.ev[c] )
		return d

	def fromList( list ):
		ret = EncodingVector()
		ret.setFromList( list )
		return ret
	fromList = staticmethod(fromList)
	
	def fromFile( filePath ):
		file = open( filePath, "r" )
		enc = file.read()
		file.close()
		
		start_re = re.compile("(/[^ ]+)[ ]+\[", re.M)
		m = start_re.search( enc )
		enc = enc[m.end(0):]
		
		name_re = re.compile("(/[^ \n\r\t]+)[ \n\r\t]")
		list = [ m.group(1) for m in name_re.finditer( enc ) ]
		return EncodingVector.fromList( list )
	fromFile = staticmethod(fromFile)
	
StandardEncodingVector = [
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/.notdef",
"/space",
"/exclam",
"/quotedbl",
"/numbersign",
"/dollar",
"/percent",
"/ampersand",
"/quoteright",
"/parenleft",
"/parenright",
"/asterisk",
"/plus",
"/comma",
"/hyphen",
"/period",
"/slash",
"/zero",
"/one",
"/two",
"/three",
"/four",
"/five",
"/six",
"/seven",
"/eight",
"/nine",
"/colon",
"/semicolon",
"/less",
"/equal",
"/greater",
"/question",
"/at",
"/A",
"/B",
"/C",
"/D",
"/E",
"/F",
"/G",
"/H",
"/I",
"/J",
"/K",
"/L",
"/M",
"/N",
"/O",
"/P",
"/Q",
"/R",
"/S",
"/T",
"/U",
"/V",
"/W",
"/X",
"/Y",
"/Z",
"/bracketleft",
"/backslash",
"/bracketright",
"/asciicircum",
"/underscore",
"/quoteleft",
"/a",
"/b",
"/c",
"/d",
"/e",
"/f",
"/g",
"/h",
"/i",
"/j",
"/k",
"/l",
"/m",
"/n",
"/o",
"/p",
"/q",
"/r",
"/s",
"/t",
"/u",
"/v",
"/w",
"/x",
"/y",
"/z",
"/braceleft",
"/bar",
"/braceright",
"/asciitilde",
"/exclamdown",
"/cent",
"/sterling",
"/fraction",
"/yen",
"/florin",
"/section",
"/currency",
"/quotesingle",
"/quotedblleft",
"/guillemotleft",
"/guilsinglleft",
"/guilsinglright",
"/fi",
"/fl",
"/endash",
"/dagger",
"/daggerdbl",
"/periodcentered",
"/paragraph",
"/bullet",
"/quotesinglbase",
"/quotedblbase",
"/quotedblright",
"/guillemotright",
"/ellipsis",
"/perthousand",
"/questiondown",
"/grave",
"/acute",
"/circumflex",
"/tilde",
"/macron",
"/breve",
"/dotaccent",
"/dieresis",
"/ring",
"/cedilla",
"/hungarumlaut",
"/ogonek",
"/caron",
"/emdash",
"/AE",
"/ordfeminine",
"/Lslash",
"/Oslash",
"/OE",
"/ordmasculine",
"/ae",
"/dotlessi",
"/lslash",
"/oslash",
"/oe",
"/germandbls",
"/apple",
"/Ydieresis",
"/lozenge",
"/Delta",
"/approxequal",
"/radical",
"/Omega",
"/integral",
"/pi",
"/product",
"/summation",
"/partialdiff",
"/greaterequal",
"/lessequal",
"/infinity",
"/notequal",
"/trademark",
"/zcaron",
"/Zcaron",
"/scaron",
"/Scaron",
"/ydieresis",
"/thorn",
"/yacute",
"/udieresis",
"/ucircumflex",
"/uacute",
"/ugrave",
"/divide",
"/odieresis",
"/otilde",
"/ocircumflex",
"/oacute",
"/ograve",
"/ntilde",
"/eth",
"/idieresis",
"/icircumflex",
"/iacute",
"/igrave",
"/edieresis",
"/ecircumflex",
"/eacute",
"/egrave",
"/ccedilla",
"/aring",
"/adieresis",
"/atilde",
"/acircumflex",
"/aacute",
"/agrave",
"/Thorn",
"/Yacute",
"/Udieresis",
"/Ucircumflex",
"/Uacute",
"/Ugrave",
"/multiply",
"/Odieresis",
"/Otilde",
"/Ocircumflex",
"/Oacute",
"/Ograve",
"/Ntilde",
"/Eth",
"/Idieresis",
"/Icircumflex",
"/Iacute",
"/Igrave",
"/Edieresis",
"/Ecircumflex",
"/Eacute",
"/Egrave",
"/Ccedilla",
"/Aring",
"/Adieresis",
"/Atilde",
"/Acircumflex",
"/Aacute",
"/Agrave",
"/mu",
"/plusminus",
"/degree",
"/registered",
"/logicalnot",
"/copyright",
"/brokenbar",
"/nbspace",
"/minus",
"/threesuperior",
"/twosuperior",
"/onesuperior",
"/threequarters",
"/onehalf",
"/onequarter",
]

if __name__ == "__main__":
	import sys
	fname = sys.argv[1]
	print EncodingVector.fromFile( fname )
